<template>
  <div @click="LoadDetails" class="card">
    <div class="movie-card">
      <img
        v-if="movie.backdrop_path"
        :src="`http://image.tmdb.org/t/p/w500/${movie.backdrop_path}`"
        width="100"
        height="100"
        :alt="movie.title"
      />

      <h1>{{ movieTemp.title }}</h1>
      <div class="movie-info p-style">
        <span class="row" title="Popularność">
          <i class="fas fa-chart-line"></i>
          <p>{{ movie.popularity }}</p>
        </span>
        <span class="row" title="Głosy">
          <i class="fas fa-star"></i>
          <p>{{ movie.vote_count }}</p>
        </span>
      </div>
    </div>

    <div class="movie-details dropdown" v-if="showPreview">
      <div class="divider"></div>
      <div class="p-style">
        <p>Gatunki: {{ movie.details.genres.map((g) => g.name).join(", ") }}</p>
        <p>
          Kraj produkcji:
          {{
            movieTemp.details.production_countries.map((g) => g.name).join(", ")
          }}
        </p>
      </div>

      <p>{{ movieTemp.details.overview }}</p>
      <a
        style="text-decoration: underline"
        target="_blank"
        class="imdb-link"
        :href="'https://www.imdb.com/title/' + movie.details.imdb_id"
        >Odwiedź stronę IMDb filmu &raquo;</a
      >
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from "vue-property-decorator";
import MovieModel from "@/model/movie/Movie";
import MovieService from "@/service/movie/MovieService";

@Component({
  components: {},
})
export default class Movie extends Vue {
  @Prop() private movie!: MovieModel;
  private showPreview = false;

  get movieTemp() {
    return this.movie;
  }

  async LoadDetails() {
    await MovieService.loadDetails(this.movie);

    this.showPreview = !this.showPreview;
    console.log(this.movie.details);
  }
}
</script>

<style scoped lang="scss">
$primary: #11998e;
$secondary: #38ef7d;

.divider {
  justify-content: center;
  padding: 0.25rem;
  border-bottom: 2px solid #858383;
  margin: 0 1rem 0.25rem 1rem;
}
.row {
  display: flex;
  flex-direction: row;
  align-items: baseline;
  justify-content: center;
}
.card {
  cursor: pointer;
  max-width: 340px;
  display: flex;
  flex-direction: column;
  justify-content: center;
  background: #2e2e2e;
  margin: 0.5rem;
  border-bottom-left-radius: 0.25rem;
  border-bottom-right-radius: 0.25rem;
  -webkit-box-shadow: 4px 2px 34px 0px rgba(0, 0, 0, 1);
  -moz-box-shadow: 4px 2px 34px 0px rgba(0, 0, 0, 1);
  box-shadow: 4px 2px 34px 0px rgba(0, 0, 0, 1);
  padding-bottom: 0.5rem;
}

button {
  background: transparent;
  border-style: none;
  outline: none;
}

button:hover {
  background: #3d3d3d;
}

button i {
  color: black;
}

h1 {
  font-size: 1.5rem;
  font-family: Baskerville, Times, "Times New Roman", serif;
  font-variant: small-caps;
  text-align: center;
  font-weight: bold;
  padding-top: 0.25rem;
  margin: 0.25rem;
}

p {
  margin: 0;
  padding: 0.25rem;
}

img {
  width: 100%;
  height: auto;
  -webkit-box-shadow: inset -1px -60px 24px -27px rgba(66, 68, 90, 1);
  -moz-box-shadow: inset -1px -60px 24px -27px rgba(66, 68, 90, 1);
  box-shadow: inset -1px -60px 24px -27px rgba(66, 68, 90, 1);
}
.movie-card:hover {
  opacity: 0.7;
  z-index: 2;
}

.movie-info {
  display: flex;
  justify-content: space-evenly;
  flex-direction: row;
}

.p-style {
  font-size: 0.75rem;
}
.imdb-link {
  text-decoration: none;
  color: #f8f0e3;
}

.imdb-link:hover {
  background: -webkit-linear-gradient($primary, $secondary);
  -webkit-background-clip: text;
  -webkit-text-fill-color: transparent;
}

@media (min-width: 576px) {
  h1 {
    max-width: 300px;
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
  }
}
@media (min-width: 576px) {
  .card {
    position: relative;
  }
  .dropdown {
    display: inline-block;
    position: absolute;
    top: 99%;
    z-index: 99;
    //overflow: visible;
    background: #2e2e2e;
    padding-bottom: 0.5rem;
    cursor: pointer;
    max-width: 340px;

    border-bottom-left-radius: 0.25rem;
    border-bottom-right-radius: 0.25rem;
    -webkit-box-shadow: 1px 57px 60px -27px rgba(0, 0, 0, 1);
    -moz-box-shadow: 1px 57px 60px -27px rgba(0, 0, 0, 1);
    box-shadow: 1px 57px 60px -27px rgba(0, 0, 0, 1);
  }
}
</style>
